import { ObservableInput } from "rxjs";
import { switchMap } from "rxjs/operators";
/**
 * A function returning an Observable representing an effect.
 * Also may return Promises, generators, per RxJS' ObservableInput type.
 */
interface EffectFactory<T, U> {
    (item: T): ObservableInput<U>;
}
export declare function useConcurrentEffect<T, U>(listener: EffectFactory<T, U>, op: typeof switchMap): [(item: T) => void, () => void];
export declare function useASAPEffect<T, U>(listener: EffectFactory<T, U>): [(item: T) => void, () => void];
export {};
