import { Event, EventMatcher, Listener, ListenerConfig } from "polyrhythm";
/** Executes the Observable or Promise-returning listener in parallel (RxJS mergeMap) mode. */
export declare function useASAPListener(matcher: EventMatcher, listener: Listener<Event, any>, options?: ListenerConfig): [(type: string, payload: any) => void, () => import("polyrhythm").Subscription];
/** Executes the Observable or Promise-returning listener in a serial, queueing (RxJS concatMap) mode. */
export declare function useQueuedListener(matcher: EventMatcher, listener: Listener<Event, any>, options?: ListenerConfig): [(type: string, payload: any) => void, () => import("polyrhythm").Subscription];
/** Executes the Observable or Promise-returning listener in a sliding, replacing (RxJS switchMap) mode. */
export declare function useRestartingListener(matcher: EventMatcher, listener: Listener<Event, any>, options?: ListenerConfig): [(type: string, payload: any) => void, () => import("polyrhythm").Subscription];
/** Executes the Observable or Promise-returning listener in a singleton, ignoring (RxJS exhaustMap) mode. */
export declare function useThrottledListener(matcher: EventMatcher, listener: Listener<Event, any>, options?: ListenerConfig): [(type: string, payload: any) => void, () => import("polyrhythm").Subscription];
/** Executes the Observable or Promise-returning listener in a toggling mode. */
export declare function useToggledListener(matcher: EventMatcher, listener: Listener<Event, any>, options?: ListenerConfig): [(type: string, payload: any) => void, () => import("polyrhythm").Subscription];
